		.title	srambuf - main


* Include File -------------------------------- *

		.include	console.mac
		.include	doscall.mac
		.include	iocscall.mac


* Global Symbol ------------------------------- *

		.xref	cmd_exec
		.xref	header
		.xref	iocs_b_verify
		.xref	fddio_hook_table
		.xref	dmamove_hook_table


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even
keep_end:

* ܂ŏ풓 ------------------------------ *

start::
		IOCS	_ROMVER
.ifdef X68030
		cmpi.l	#$13_921127,d0
.else
		cmpi.l	#$11_910111,d0		;XVI
.endif
		bne	romver_error

		bsr	keep_check
		bne	already_error

		lea	(fddio_hook_table,pc),a0
		bsr	hook_vec
		lea	(dmamove_hook_table,pc),a0
		bsr	hook_vec
		bsr	fdd_init
.ifdef TEST
		bsr	test
.endif
		pea	(header,pc)
		DOS	_PRINT
		pea	(crlf_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp

		clr	-(sp)
		pea	(keep_end-cmd_exec).w
		DOS	_KEEPPR

romver_error:
		pea	(romver_err_mes,pc)
		bra	@f
already_error:
		pea	(already_err_mes,pc)
		bra	@f
@@:
		DOS	_PRINT
		addq.l	#4,sp
		move	#1,-(sp)
		DOS	_EXIT2


* Tu[` -------------------------------- *

keep_check:
		movem.l	d0-d1/a0-a1,-(sp)
		clr.l	-(sp)
		DOS	_SUPER
		move.l	d0,(sp)

		movea.l	($400+_B_VERIFY*4),a0
		lea	(header-iocs_b_verify,a0),a0
		lea	(header,pc),a1
		moveq	#0,d1
@@:
		cmpm.b	(a0)+,(a1)+
		bne	keep_check_end
		tst.b	(-1,a0)
		bne	@b
		moveq	#-1,d1
keep_check_end:
		DOS	_SUPER
		move.l	d1,(sp)+
		movem.l	(sp)+,d0-d1/a0-a1
		rts

hook_vec:
hook_loop:
		move	(a0),d1			;xN^ԍ
		move.l	(a0),d0
		lea	(a0,d0.w),a1		;AhX
		IOCS	_B_INTVCS
		move.l	d0,(a0)+		;ȑÕAhXۑ
		tst	(a0)
		bpl	hook_loop
		rts

fdd_init:
		move	#$90_00,d1
dskinit_loop:
		moveq	#0,d2			;FDD 
		suba.l	a1,a1
		IOCS	_B_DSKINI
		addi	#$01_00,d1
		cmpi	#$93_00,d1
		bls	dskinit_loop
		rts

.ifdef TEST
		clr.l	-(sp)
		DOS	_SUPER
		move.l	d0,(sp)

		move	#$90_60,d1
		move.l	#3<<24+0<<16+0<<8+1,d2
		move.l	#1024,d3
		lea	(buf,pc),a1
		movea.l	($400+_B_READ*4)
		jsr	(a0)
		DOS	_SUPER
		addq.l	#4,sp
		rts

		.bss
buf:		.ds.b	1024
		.text
.endif


* Data Section -------------------------------- *

		.data
		.even

romver_err_mes:
.ifdef X68030
		.dc.b	'IOCS ROM version 1.3 ȊOł͑gݍ߂܂.',CRLF,0
.else
		.dc.b	'IOCS ROM version 1.1 ȊOł͑gݍ߂܂.',CRLF,0
.endif
already_err_mes:
		.dc.b	'ɑgݍ܂Ă܂.'
crlf_mes:
		.dc.b	CRLF,0


		.end

* End of File --------------------------------- *
