		.title	vcache - MPU/VENUS-X LbV

program:	.reg	'vcache'
version:	.reg	'1.01'
date:		.reg	'1999/02/11'
author:		.reg	'Ԃq'


* Include Files ------------------------------- *

		.include	dos.mac
		.include	macro.mac
		.include	console.mac
		.include	doscall.mac
		.include	iocscall.mac
		.include	iocswork.mac


* I/O Address --------------------------------- *

XT30_ID3:	.equ	$ecc000+$100

VX_CTRL:	.equ	$ecf000
VX_ID1:		.equ	$ecf004
VX_ID2:		.equ	$ecf008
VX_REV:		.equ	$ecf00c


* Constant ------------------------------------ *

VX_BIT:		.equ	7
DATA_BIT:	.equ	1
INST_BIT:	.equ	0


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

		bra	@f
		.dc.b	'#HUPAIR',0
@@:
		bsr	get_cache_bit		;d5.lw = ݂LbV@\
		move.l	d0,d5			;d5.hw = verbose tO

		bsr	get_cache_status	;d6.lw = ݂̏
		move.l	d0,d6			;d6.hw = short tO

		moveq	#0,d7			;v|d|i w
						;ŏʃrbg=1 Ȃ牽s
		pea	(1,a2)
		bsr	GetArgCharInit
		addq.l	#4,sp
arg_next:
		bsr	GetArgChar_lower
arg_next2:
		tst.l	d0
		beq	arg_next
		bmi	arg_end

		cmpi.b	#'-',d0
		bne	arg_not_option
*arg_option:
		bsr	GetArgChar		;v/V ̂ _lower ͑ʖ
		cmpi.b	#'-',d0
		beq	long_option		;--long-option
arg_option_loop:
		cmpi.b	#'?',d0
		beq	print_usage
		ori.b	#$20,d0
		cmpi.b	#'h',d0
		beq	print_usage
		cmpi.b	#'v',d0
		beq	verbose_option
		cmpi.b	#'s',d0
		bne	arg_error
*short_option:
		not.l	d6
		not	d6			;ʃ[h𔽓]
		bra	arg_option_next
verbose_option:
		not.l	d5
		not	d5			;ʃ[h𔽓]
arg_option_next:
		bsr	GetArgChar_lower
		tst.b	d0
		bne	arg_option_loop
		bra	arg_next2

short_long_opt:
		not.l	d6
		not	d6			;ʃ[h𔽓]
		bra	arg_next
verbose_long_opt:
		not.l	d5
		not	d5			;ʃ[h𔽓]
		bra	arg_next

* --help, --short, --version, --verbose
long_option:
		subq.l	#LONGOPT_MAX+1,sp
		lea	(sp),a0
		moveq	#LONGOPT_MAX,d1
get_long_opt_loop:
		bsr	GetArgChar
		move.b	d0,(a0)+
		dbeq	d1,get_long_opt_loop
		bne	arg_error		;

		lea	(long_opt_tbl,pc),a0
long_opt_cmp_loop:
		tst	(a0)
		beq	arg_error		;݂ȂIvV
		lea	(a0),a1
		adda	(a0)+,a1		;̃AhX
		lea	(a0),a3
		adda	(a0)+,a3		;AhX
		lea	(sp),a2
@@:
		cmpm.b	(a1)+,(a2)+		;r
		bne	long_opt_cmp_loop
		tst.b	(-1,a1)
		bne	@b
		jmp	(a3)

LONGOPT:	.macro	str,job
		.dc	str-$,job-$
		.endm
long_opt_tbl:
		LONGOPT	str_help,	print_usage
		LONGOPT	str_short,	short_long_opt
		LONGOPT	str_verbose,	verbose_long_opt
		LONGOPT	str_version,	print_version
		.dc	0

arg_not_option:
		moveq	#$20,d2
		or.b	d2,d0			;
		cmpi.b	#'v',d0
		bne	@f
		.if	VX_BIT.eq.7
		tas	d7			;񎟃LbV̎w肠
		.else
		bset	#VX_BIT,d7
		.endif
		bra	arg_next
@@:		cmpi.b	#'d',d0
		bne	@f
		ori	#1<<DATA_BIT,d7		;f[^LbVV
		bra	arg_next
@@:		cmpi.b	#'i',d0
		bne	@f
		ori	#1<<INST_BIT,d7		;߃LbVV
		bra	arg_next
@@:
		cmpi.b	#'o',d0
		bne	arg_error
		bsr	GetArgChar_lower
		cmpi.b	#'n',d0
		bne	arg_not_on
		lea	(cache_on,pc),a0
arg_onoff:
		.if	0
		bsr	GetArgChar_lower	;Ďwł
		tst.b	d0
		bne	arg_error
		.endif
		tst	d7			;on / off
		bne	@f
		move	d5,d7			;v|d|i wȂS
@@:
		jsr	(a0)			;cache_{on,off}
		moveq	#1,d7
		ror.l	#1,d7
		bra	arg_next
arg_not_on:
		moveq	#'f',d1
		cmp.b	d1,d0
		bne	arg_error
		bsr	GetArgChar_lower
		cmp.b	d1,d0
		bne	arg_error
		lea	(cache_off,pc),a0
		bra	arg_onoff


GetArgChar_lower:
		bsr	GetArgChar
		cmpi.b	#'A',d0
		bcs	@f
		cmpi.b	#'Z',d0
		bhi	@f
		ori.b	#$20,d0
@@:		rts


* ͏I.
* v/d/i ݂̂w肳ĂAw肳ꂽ̂ on ɁAȊO
*  off ɂ.
* -sA--short w肳ĂΌ(ύX)̏Ԃ\.
* v/d/i/on/off xw肳ĂȂΌ݂̏Ԃ\.
* on/off w肳ꂽȂ牽I.

arg_end:
		tst	d7
		beq	@f

		bsr	cache_change		;v/d/i Ȃݒ
		moveq	#-1,d7
@@:
		tst.l	d6
		bmi	print_status_short	;--short ȂɊȗ\
		.ifdef	VERBOSE
		bra	print_status		;ɏԕ\...
		.else
		tst.l	d5
		bmi	print_status		;--verbose Ȃɏԕ\
		tst.l	d7
		beq	print_status		;wȂԕ\
*exit:
		DOS	_EXIT
		.endif


* ԕ\ ------------------------------------ *
* in	d5.w	LbV
*	d6.w	LbV

print_status:
		lea	(stat_table,pc),a0
		lea	(str_buf,pc),a1
		pea	(a1)
print_status_loop:
		lea	(a0),a2
		adda	(a0)+,a2		;LbV̎
		STRCPY	a2,a1
		subq.l	#1,a1

		move	(a0)+,d0		;rbgʒu
		lea	(nothing_mes,pc),a2
		btst	d0,d5
		beq	@f
		lea	(on_mes,pc),a2
		btst	d0,d6
		bne	@f
		addq.l	#off_mes-on_mes,a2
@@:
		STRCPY	a2,a1			;
		subq.l	#1,a1
		.ifdef	__CRLF__
		move.b	#CR,(a1)+
		.endif
		move.b	#LF,(a1)+

		tst	d0
		bne	print_status_loop	;INST_BIT=0 ŏI

		clr.b	(a1)
		DOS	_PRINT
		DOS	_EXIT

stat_table:
		.dc	  vx_mes-$,  VX_BIT
		.dc	data_mes-$,DATA_BIT
		.dc	inst_mes-$,INST_BIT
		.even


* ȗ\ ------------------------------------ *
* in	d5.w	LbV
*	d6.w	LbV

print_status_short:
		lea	(off_crlf_mes,pc),a0
		tst	d6
		beq	9f			;S off
		subq.l	#off_crlf_mes-on_crlf_mes,a0
		cmp	d5,d6
		beq	9f			;S on

		lea	(crlf_mes,pc),a0
		lsr.b	#1,d6
		bcc	@f
		.fail	INST_BIT.ne.0
		move.b	#'i',-(a0)
@@:
		lsr.b	#1,d6
		bcc	@f
		.fail	DATA_BIT.ne.1
		move.b	#'d',-(a0)
@@:
		lsr.b	#VX_BIT-2+1,d6
		bcc	@f
		move.b	#'v',-(a0)
@@:
9:		pea	(a0)
		DOS	_PRINT
		DOS	_EXIT


* LbV ------------------------------ *
*
* in	d5.w	LbV
*	d6.w	݂̃LbV
*	d7.w	ύXLbV
* out	d6.w	ύX̃LbV
* break	d0

cache_change:
		move	d7,d0			;wLbV onA off
		bra	@f
cache_on:
		move	d6,d0			;wLbV onA͕s
		or	d7,d0
		bra	@f
cache_off:
		move	d6,d0			;wLbV offA͕s
		not	d7
		and	d7,d0
		not	d7
@@:
		movem.l	d1-d3/a0,-(sp)
		and	d5,d0			;LbV𖳎
		move	d0,d3			;ݒ肷

		eor	d6,d0
		lsl.b	#6,d0			;%di00_0000
		.fail	(DATA_BIT.ne.1).or.(INST_BIT.ne.0)
		beq	@f			;ύXȂ

		moveq	#1<<DATA_BIT+1<<INST_BIT,d2
		and	d3,d2
		moveq	#4,d1			;LbV̐ݒ
		IOCS	_SYS_STAT
@@:
		eor.b	d3,d6
		bpl	@f			;ύXȂ

		lea	(VX_CTRL),a1
		IOCS	_B_LPEEK
		subq.l	#4,a1
		move.l	d0,d1
		bchg	#VX_BIT,d1		;on <-> off
		IOCS	_B_LPOKE
@@:
		move	d3,d6
		movem.l	(sp)+,d1-d3/a0
		rts


* Tu[` -------------------------------- *

* MPU/VENUS-X ̃LbVԂ.
* in	d5.l	LbV
* out	d0.l	bit 7=1:VENUS-X 2nd	cache on
*		bit 1=1:MPU data	V
*		bit 1=0:MPU instruction	V
*		rbg̒l 0 Ȃ cache off.
*		̑̃rbg͑S 0.

get_cache_status:
		movem.l	d6/a0-a1,-(sp)
		moveq	#0,d6
		lea	(MPUTYPE),a1
		IOCS	_B_BPEEK
		subq.b	#2,d0
		bcs	@f			;68000/68010

		moveq	#1,d1			;LbVԎ
		IOCS	_SYS_STAT
		move.b	d0,d6
@@:
		.if	VX_BIT.eq.7
		tst.b	d5
		bpl	@f			;VENUS-X ĂȂ
		.else
		btst	#VX_BIT,d5
		beq	@f
		.endif

		lea	(VX_CTRL),a1
		IOCS	_B_LPEEK
		tst.b	d0
		bpl	@f			;񎟃LbVOFF

		.if	VX_BIT.eq.7
		tas	d6
		.else
		bset	#VX_BIT,d6
		.endif
@@:
		move.l	d6,d0
		movem.l	(sp)+,d6/a0-a1
		rts


* ĂLbV̎ނ𓾂.
* out	d0.l	bit 7=1:VENUS-X 2nd	
*		bit 1=1:MPU data	V
*		bit 1=0:MPU instruction	V
*		rbg̒l 0 Ȃ疢.
*		̑̃rbg͑S 0.

get_cache_bit:
		movem.l	d5/a0-a1,-(sp)
		moveq	#0,d5
		lea	(MPUTYPE),a1
		IOCS	_B_BPEEK
		subq.b	#2,d0
		bcs	@f			;68000/68010

		moveq	#1<<INST_BIT,d5
		tst.b	d0
		beq	@f			;68020
		addq.b	#1<<DATA_BIT,d5		;68030/68040/68060
@@:
		bsr	is_exist_venus_x
		beq	@f			;VENUS-X ĂȂ

		.if	VX_BIT.eq.7
		tas	d5
		.else
		bset	#VX_BIT,d5
		.endif
@@:
		move.l	d5,d0
		movem.l	(sp)+,d5/a0-a1
		rts


* VENUS-X ݌.
* out	d0.l	0:VENUS-X ݂͑Ȃ 1:݂
*	ccr	<tst.l d0> ̌

is_exist_venus_x:
		move.l	a0,-(sp)
		lea	(XT30_ID3),a0
		bsr	check_bus_error_word
		beq	is_exist_vx_false	;Xellent30(ID=3)L

		lea	(VX_CTRL-XT30_ID3,a0),a0
		bsr	check_bus_error_long
		bne	is_exist_vx_false	;VENUS-X ͖

	.irp	id,'V','X'
		addq.l	#4,a0
		bsr	check_bus_error_long
		bne	is_exist_vx_false
		cmpi.b	#id,d0
		bne	is_exist_vx_false	;Ö׎ʎq𒲂ׂ
	.endm
*is_exist_vx_true:
		moveq	#1,d0
is_exist_vx_end:
		movea.l	(sp)+,a0
		rts
is_exist_vx_false:
		moveq	#0,d0
		bra	is_exist_vx_end


* wAhXǂ݂ŃoXG[邩ׂ.
* in	a0.l	AhX
* out	d0.bwl	ǂݍ񂾃f[^
*	ccr	Z=1:I Z=0:oXG[

check_bus_error_word:
		move	#2,-(sp)
		move.l	sp,-(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		move	(8,sp),d0
		bra	@f
check_bus_error_long:
		move	#4,-(sp)
		subq.l	#4,sp
		move.l	sp,(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		move.l	(4,sp),d0
@@:		tst.l	(sp)+
		addq.l	#10-4,sp
		rts


* G[ ---------------------------------- *

print_version:
		lea	(ver_mes_end,pc),a0
		.ifdef	__CRLF__
		move.b	#CR,(a0)+
		.endif
		move.b	#LF,(a0)+
		clr.b	(a0)
		pea	(title_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
		DOS	_EXIT

print_usage:
		pea	(title_mes,pc)
		DOS	_PRINT
		pea	(usage_mes,pc)
		DOS	_PRINT
		addq.l	#8,sp
		DOS	_EXIT

arg_error:
		lea	(arg_err_mes,pc),a0
		bra	error_exit

error_exit:
		move	#STDERR,-(sp)
		move.l	a0,-(sp)
		DOS	_FPUTS
		addq.l	#6,sp

		move	#1,-(sp)
		DOS	_EXIT2


* HUPAIR Decoder ------------------------------ *

		.if	0
GetArgChar_p:	.dc.l	0
GetArgChar_c:	.dc.b	0
		.even
		.else
GetArgChar_p:	.equ	GetArgCharInit
GetArgChar_c:	.equ	GetArgCharInit+4
		.endif

GetArgChar:
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(GetArgChar_p,pc),a0
		movea.l	(a0)+,a1
		move.b	(a0),d0
		bmi	GetArgChar_noarg
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_endarg
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.b	d1,(a0)
		move.l	a1,-(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_endarg:
		st	(a0)
		bra	GetArgChar_abort
GetArgChar_noarg:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_abort

GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next

GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		moveq	#0,d0
		tst.b	-(a1)
		beq	GetArgChar_endarg
		bra	GetArgChar_end

GetArgCharInit:
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		tst.b	-(a1)
		lea	(GetArgChar_c,pc),a0
		seq	(a0)
		move.l	a1,-(a0)
		movem.l	(sp)+,a0-a1
		rts


* Data Section -------------------------------- *

		.data
		.even

title_mes:	.dc.b	program,' version ',version
ver_mes_end:	.dc.b	'  ',date,' ',author,'.',CRLF,0

vx_mes:		.dc.b	'VENUS-X 񎟃LbV...',0
data_mes:	.dc.b	'f[^LbV.........',0
inst_mes:	.dc.b	'߃LbV...........',0

*vx_mes:	.dc.b	'VENUS-X 2nd cache........',0
*data_mes:	.dc.b	'Data cache...............',0
*inst_mes:	.dc.b	'Instruction cache........',0

on_mes:		.dc.b	'nm',0
off_mes:	.dc.b	'nee',0
nothing_mes:	.dc.b	'',0

*on_mes:	.dc.b	'ON',0
*off_mes:	.dc.b	'OFF',0
*nothing_mes:	.dc.b	'NOTHING',0
*on_mes:	.dc.b	'enable',0
*off_mes:	.dc.b	'disable',0
*nothing_mes:	.dc.b	'nothing',0
*on_mes:	.dc.b	'L',0
*off_mes:	.dc.b	'',0
*nothing_mes:	.dc.b	'',0

str_buf:
usage_mes:	.dc.b	'usage: ',program,' [option] [v|d|i] [on|off] ...',CRLF
		.dc.b	'command:',CRLF
		.dc.b	'	v	VENUS-X 񎟃LbV',CRLF
		.dc.b	'	d	f[^LbV',CRLF
		.dc.b	'	i	߃LbV',CRLF
		.dc.b	'	on	LbV ON(v|d|i ȗ͑SĂΏ)',CRLF
		.dc.b	'	off	LbV OFF(V)',CRLF
		.dc.b	'	(ȗ)	݂̏Ԃ\',CRLF
		.dc.b	'option:',CRLF
		.dc.b	'	-s, --short	Ԃ̊ȗ\',CRLF
		.dc.b	'	-v, --verbose	command w莞ύX̏Ԃ\',CRLF
		.dc.b	0

arg_err_mes:	.dc.b	'܂.'
crlf_mes:	.dc.b	CRLF,0

* ǉꍇ long_opt_tbl ύX邱.
LONGOPT_MAX:	.equ	7
str_help:	.dc.b	'help',0
str_short:	.dc.b	'short',0
str_verbose:	.dc.b	'verbose',0
str_version:	.dc.b	'version',0

on_crlf_mes:	.dc.b	'on',CRLF,0
off_crlf_mes:	.dc.b	'off',CRLF,0


		.end

* End of File --------------------------------- *
