		.title	Yurika system - inst(CXg[)


* Include File -------------------------------- *

		.include	yurika.mac

		.include	dos.mac
		.include	sram.mac
		.include	iomap.mac
		.include	macro.mac
		.include	console.mac
		.include	doscall.mac
		.include	iocscall.mac


* Global Symbol ------------------------------- *

		.xref	sram_start,sram_end


* Constant ------------------------------------ *

		.ifndef	VXMASK
VXMASK:		.equ	$ff
		.endif

		.ifndef	VXMODE
VXMODE:		.equ	$80
		.endif


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

		lea	(sram_start,pc),a6
		lea	(SRAM_PROG),a5
		
* ^Cg\
		pea	(title_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp

* CXg[\ǂׂ
		lea	(SRAM_USEMODE-SRAM_PROG,a5),a1
		IOCS	_B_BPEEK
		tst.b	d0
		bne	sram_used_error

* CXg[Jn̊mF
		pea	(ask_yn,pc)
		DOS	_PRINT
		DOS	_INKEY
		moveq	#$20,d1
		or.b	d0,d1

		lea	(_crlf,pc),a0
		move.b	d0,(a0)
		move.l	a0,(sp)
		DOS	_PRINT
		addq.l	#4,sp

		cmpi.b	#'y',d1
		bne	exit

* O
		TO_SUPER
		move.l	(SRAM_OFFTIMES-SRAM_PROG,a5),(~sram_offtime,a6)
**		clr.l	(~sram_vdispst,a6)
		move	(SRAM_BOOT-SRAM_PROG,a5),(~sram_boot,a6)
		move.b	#VXMASK,(~sram_vxmask,a6)
		move.b	#VXMODE,(~sram_vxmode,a6)

* SRAM 풓̓]
		bsr	write_enable
		lea	(a6),a0
		lea	(a5),a1
		move	#(sram_end-sram_start)/4-1,d0
@@:
		move.l	(a0)+,(a1)+		;SRAM ɏ
		dbra	d0,@b

* ŏIݒ
		DI				;SRAM Nɐݒ肷
		move.b	#2,(SRAM_USEMODE-SRAM_PROG,a5)
		move.l	a5,(SRAM_SRAMBOOT-SRAM_PROG,a5)
		move	#$b000,(SRAM_BOOT-SRAM_PROG,a5)
		EI
		bsr	write_disable

* CXg[
		TO_USER
		pea	(ok_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
exit:
		DOS	_EXIT


* Tu[` -------------------------------- *

* SRAM ݋/֎~

write_enable:
		move.b	#$31,-(sp)
		bra	@f
write_disable:
		clr.b	-(sp)
@@:		move.b	(sp)+,(SYS_P7)
		rts


* G[ ---------------------------------- *

sram_used_error:
		pea	(sram_used_mes,pc)
		bra	@f


@@:
		DOS	_PRINT
		move	#1,(sp)
		DOS	_EXIT


* Data Section -------------------------------- *

**		.data
		.even

title_mes:	.dc.b	SYSNAME,' version ',VERSION,'  ',DATE,' ',AUTHOR,CRLF,0

_crlf:		.dc.b	'?',CRLF,0

ask_yn:		.dc.b	'Yurika system  SRAM ɃCXg[܂.',CRLF
		.dc.b	'낵łH(y/[n]):',0
ok_mes:		.dc.b	'CXg[܂.',CRLF,0

sram_used_mes:	.dc.b	'SRAM ͊ɎgpĂ܂.',CRLF,0


		.even
		.end

* End of File --------------------------------- *
